; ===========================================================================

.686p
.mmx
.model flat

includelib lib\kernel32.lib
includelib Lib\user32.lib

; ===========================================================================
; Imports from Kernel32.dll
; ===========================================================================

; HMODULE __stdcall LoadLibraryA(LPCWSTR lpLibFileName)
extrn _imp__LoadLibraryA@4 : dword

; FARPROC __stdcall GetProcAddress(HMODULE hModule, LPCSTR lpProcName)
extrn _imp__GetProcAddress@8 : dword

; BOOL __stdcall FreeLibrary(HMODULE hLibModule)
extrn _imp__FreeLibrary@4 : dword

; void __stdcall ExitProcess(UINT uExitCode)
extrn _imp__ExitProcess@4 : dword

; ===========================================================================
; Imports from User32.dll
; ===========================================================================

; int __stdcall MessageBoxA(HWND hWnd, LPCSTR lpText, LPCSTR lpCaption, UINT uType)
extrn _imp__MessageBoxA@16 : dword

; ===========================================================================

MB_OK         	equ 0h

; ===========================================================================

.data

hOurDll 		dd 0  ; HMODULE hOurDll

szTestDll		db "comctl32.dll", 0
szFuncName 		db "DllInstall", 0  ;   InitCommonControlsEx

Header      	db "Info", 0
ErrHeader      	db "Error", 0
ErrMsgDll     	db "Load comctl32.dll is wrong!", 0
MsgInfo     	db "Function DllInstall is Ok!", 0
ErrMsgFunc     	db "Function DllInstall is wrong!", 0

; ===========================================================================

.code

_Start:
	push offset szTestDll
	call ds:_imp__LoadLibraryA@4  ; LoadLibraryA(x)		

	mov hOurDll, eax
	
	test eax, eax		
	jz short ErrorDll

	push offset szFuncName ; "DllInstall"
	push eax  ; hOurDll
	
	call ds:_imp__GetProcAddress@8 ; GetProcAddress(x,x)

	test eax, eax		
	jz short ErrorFunc
		
    push 0
    push 1

	call eax  ; szFuncName

    push MB_OK
    push offset Header
    push offset MsgInfo
    push 0

    call _imp__MessageBoxA@16  ;      
		
	jmp short Free	

ErrorDll:
    push MB_OK
    push offset ErrHeader
    push offset ErrMsgDll
    push 0

    call _imp__MessageBoxA@16  ;  
		
	jmp short Quit	

ErrorFunc:
    push MB_OK
    push offset ErrHeader
    push offset ErrMsgFunc
    push 0

    call _imp__MessageBoxA@16  ;  
		
Free:
	push    hOurDll
	call    ds:_imp__FreeLibrary@4  ; FreeLibrary(x)

Quit:
    push 0
    call _imp__ExitProcess@4

end _Start

; ===========================================================================
